from pyspark.context import SparkContext
from pyspark.sql.session import SparkSession

import operator
from copy import copy

def apply_discount(tran):
    if int(tran[3]) == 25 and int(tran[4]) > 1:
        # print(tran)
        tran[5] = str(float(tran[5]) * 0.95)
    return tran

def add_prod_70(tran):
    if int(tran[3]) == 81 and int(tran[4]) > 4:
        gift = copy(tran)
        gift[3] = '70'
        gift[4] = '1'
        gift[5] = '0.0'
        return [tran, gift]
    else:
        return [tran]

if __name__ == '__main__':
    sc = SparkContext('local')
    spark = SparkSession(sc)

    tran_file = sc.textFile('data/ch04_data_transactions.txt')
    tran_data = tran_file.map(lambda t: t.split('#'))

    # prvi primjer

    tran_by_cust = tran_data.map(lambda t: (int(t[2]), t))
    print(tran_by_cust.keys().distinct().count())
    # print(tran_by_cust.collect())

    cust_counts = tran_by_cust.countByKey()
    print(type(cust_counts))
    print(cust_counts)

    cust_id, cnt = sorted(cust_counts.items(), key=operator.itemgetter(1))[-1]
    print(cust_id, cnt)

    print(tran_by_cust.lookup(53))
    gift = [['2022.10.28', '5:33 PM', '53', '4', '1', '0.0']]

    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 25).collect())
    tran_by_cust = tran_by_cust.mapValues(lambda t: apply_discount(t))
    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 25).collect())

    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 70).collect())
    tran_by_cust = tran_by_cust.flatMapValues(lambda t: add_prod_70(t))
    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 70).collect())

    amounts = tran_by_cust.mapValues(lambda t: float(t[5]))
    print(amounts.collect())

    totals = amounts.reduceByKey(lambda p1, p2: p1 + p2)
    print(totals.collect())

    cid, max_totals = sorted(totals.collect(), key=operator.itemgetter(1))[-1]
    print(cid, max_totals)

    gift.append(['2022-11-4', '5:31 PM', str(cid), '63', '1', '0.0'])

    gift_rdd = sc.parallelize(gift)
    gift_by_cust = gift_rdd.map(lambda t: (int(t[2]), t))

    print(tran_by_cust.count())
    tran_by_cust = tran_by_cust.union(gift_by_cust)
    print(tran_by_cust.count())

    # drugi primjer
    tran_by_prod = tran_data.map(lambda t: (int(t[3]), t))
    tran_by_prod_price = tran_by_prod.mapValues(lambda t: float(t[5]))
    tran_by_prod_total = tran_by_prod_price.reduceByKey(lambda p1, p2: p1 + p2)
    print(tran_by_prod_total.collect())

    prod_file = sc.textFile('data/ch04_data_products.txt')
    products = prod_file.map(lambda row: row.split('#'))
    prod_by_id = products.map(lambda prod: (int(prod[0]), prod))
    print(prod_by_id.collect())

    totals_and_products = tran_by_prod_total.join(prod_by_id)
    print(totals_and_products.collect())

    totals_and_products = totals_and_products.mapValues(lambda x: (x[1][1], x[0]))
    print(totals_and_products.collect())